"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _runtime = require("@modern-js-block/runtime");

var _g2plot = require("@antv/g2plot");

var _base = require("../base");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const rateFormatter = v => `${(v * 100).toFixed(2)}%`;

const conversionTag = {
  offsetX: 10,
  offsetY: 0,
  formatter: datum => {
    const [pre, curr] = (datum === null || datum === void 0 ? void 0 : datum.compareNumber) || [1, 1];
    return `转化率${rateFormatter(curr / pre)}`;
  }
};
const label = {
  formatter: (_text, item) => `${item._origin.stage} ${item._origin.number}`
};
const tooltip = {
  customItems: items => items.map(d => _objectSpread(_objectSpread({}, d), {}, {
    value: d.data.number
  }))
};
const FunnelChart = (0, _base.createChart)(_g2plot.Funnel, {
  transformData: options => {
    const {
      data,
      xField,
      yField
    } = options; // 把数据统一转换为{ stage, number }

    const newData = (data === null || data === void 0 ? void 0 : data.map((it, idx) => {
      var _data;

      return _objectSpread(_objectSpread({}, it), {}, {
        stage: data[idx][xField],
        number: Number(data[idx][yField]),
        compareNumber: [(data === null || data === void 0 ? void 0 : (_data = data[idx - 1]) === null || _data === void 0 ? void 0 : _data[yField]) || undefined, data[idx][yField]]
      });
    })) || []; // const total = newData?.reduce(
    //   (acc: number, it: Record<string, any>) => it.number + acc,
    //   0,
    // );

    if (newData && xField && yField) {
      newData === null || newData === void 0 ? void 0 : newData.forEach(it => {
        // it[yField] = Number(it[yField]);
        // it.totalNumber = total;
        it._number = 1;
      });
    }

    return newData || [];
  },
  transformConfig: options => {
    const newOptions = _objectSpread(_objectSpread({}, options), {}, {
      yField: '_number',
      label,
      tooltip,
      conversionTag
    });

    return newOptions;
  }
});

var _default = (0, _runtime.createBlock)({
  xField: 'stage',
  yField: 'number',
  legend: false,
  data: [],
  title: '漏斗图',
  subTitle: '',
  dynamicHeight: true
})(FunnelChart);

exports.default = _default;