"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _runtime = require("@modern-js-block/runtime");

var _g2plot = require("@antv/g2plot");

var _base = require("../base");

var _shared = require("../shared");

const LineChart = (0, _base.createChart)(_g2plot.Line, {
  transformData: c => {
    const sortedData = (0, _shared.sortTimeData)(c);
    return (0, _shared.supportMultiYFields)(c, sortedData);
  },
  transformConfig: _shared.compileFormatterStr
});

var _default = (0, _runtime.createBlock)({
  autoFit: true,
  renderer: 'svg',
  xField: 'x',
  yField: 'y',
  // yFields: ['y1', 'y2'],
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false
  },
  lineStyle: {
    lineWidth: 1
  },
  legendPosition: 'bottom',
  legendSubPosition: 'left',
  // seriesField: 'series',
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5'
        }
      }
    }
  },
  tooltip: {
    shared: true
  },
  data: [{
    x: '2019-01',
    y1: 129,
    y2: 100
  }, {
    x: '2019-02',
    y1: 119,
    y2: 90
  }, {
    x: '2019-03',
    y1: 148,
    y2: 80
  }, {
    x: '2019-04',
    y1: 160,
    y2: 60
  }],
  title: '多折线图',
  subTitle: '一个简单的折线图'
})(LineChart);

exports.default = _default;