import { createBlock } from '@modern-js-block/runtime';
import { Bar } from '@antv/g2plot';
import { createChart } from "../base";
import { sortTimeData, compileFormatterStr } from "../shared";
var BarChart = createChart(Bar, {
  transformData: sortTimeData,
  transformConfig: compileFormatterStr
});
export default createBlock({
  autoFit: true,
  renderer: 'svg',
  data: [],
  xField: 'x',
  yField: 'y',
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false
  },
  lineStyle: {
    lineWidth: 1
  },
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5'
        }
      }
    }
  }
})(BarChart);