import { createBlock } from '@modern-js-block/runtime';
import { Heatmap } from '@antv/g2plot';
import { createChart } from "../base";
var HeatmapChart = createChart(Heatmap, {
  transformData: function transformData(options) {
    var xField = options.xField,
        _options$data = options.data,
        data = _options$data === void 0 ? [] : _options$data,
        isSorted = options.isSorted;

    if (isSorted) {
      return data.sort(function (a, b) {
        return a[xField] - b[xField];
      });
    }

    return data;
  }
});
export default createBlock({
  width: 650,
  height: 500,
  autoFit: false,
  data: [],
  xField: 'Month of Year',
  yField: 'District',
  colorField: 'AQHI',
  color: ['#174c83', '#7eb6d4', '#efefeb', '#efa759', '#9b4d16']
})(HeatmapChart);