import { createEditor } from '@modern-js-block/runtime';
import FunnelChart from "../FunnelChart";
createEditor(FunnelChart, function (params) {
  var _props$data, _props$data2;

  var ControlType = params.ControlType,
      addPropertyControls = params.addPropertyControls,
      props = params.props;
  addPropertyControls({
    title: {
      type: ControlType.String,
      title: '主标题'
    },
    subTitle: {
      type: ControlType.String,
      title: '子标题'
    },
    data: {
      type: ControlType.Json,
      title: '图表数据',
      defaultValue: [{
        stage: '简历筛选',
        number: 253
      }, {
        stage: '初试人数',
        number: 151
      }, {
        stage: '复试人数',
        number: 113
      }, {
        stage: '录取人数',
        number: 87
      }, {
        stage: '入职人数',
        number: 59
      }]
    },
    xField: {
      type: ControlType.Enum,
      title: 'x轴',
      autoComplete: true,
      options: ((_props$data = props.data) === null || _props$data === void 0 ? void 0 : _props$data.length) && Object.keys(props.data[0]).map(function (key) {
        return {
          label: key,
          value: key
        };
      }) || ['x']
    },
    yField: {
      type: ControlType.Enum,
      title: 'y轴',
      autoComplete: true,
      options: ((_props$data2 = props.data) === null || _props$data2 === void 0 ? void 0 : _props$data2.length) && Object.keys(props.data[0]).map(function (key) {
        return {
          label: key,
          value: key
        };
      }) || ['y']
    },
    legend: {
      type: ControlType.Boolean,
      title: '图例显示'
    },
    width: {
      type: ControlType.Number,
      title: '宽度'
    },
    height: {
      type: ControlType.Number,
      title: '高度'
    }
  });
});