import { createBlock } from '@modern-js-block/runtime';
import { Bar, BarOptions } from '@antv/g2plot';
import { createChart, SeqChartOptions } from '@/base';
import { sortTimeData, compileFormatterStr } from '@/shared';

export type BarChartProps = SeqChartOptions<BarOptions>;

const BarChart = createChart<BarChartProps>(Bar, {
  transformData: sortTimeData,
  transformConfig: compileFormatterStr,
});

export default createBlock<BarChartProps>({
  autoFit: true,
  renderer: 'svg',
  data: [],
  xField: 'x',
  yField: 'y',
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false,
  },
  lineStyle: {
    lineWidth: 1,
  },
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5',
        },
      },
    },
  },
})(BarChart);
