import { createBlock } from '@modern-js-block/runtime';
import { Column, ColumnOptions } from '@antv/g2plot';
import { createChart, SeqChartOptions } from '@/base';
import { sortTimeData, compileFormatterStr } from '@/shared';

export type ColumnChartProps = SeqChartOptions<ColumnOptions>;

const ColumnChart = createChart<ColumnChartProps>(Column, {
  transformData: sortTimeData,
  transformConfig: compileFormatterStr,
});

export default createBlock<ColumnChartProps>({
  autoFit: true,
  renderer: 'svg',
  xField: 'x',
  yField: 'y',
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false,
  },
  lineStyle: {
    lineWidth: 1,
  },
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5',
        },
      },
    },
  },
  data: [],
})(ColumnChart);
