import { createEditor, PluginParams } from '@modern-js-block/runtime';
import FunnelChart from '@/FunnelChart';

createEditor(FunnelChart, (params: PluginParams) => {
  const { ControlType, addPropertyControls, props } = params;
  addPropertyControls({
    title: {
      type: ControlType.String,
      title: '主标题',
    },
    subTitle: {
      type: ControlType.String,
      title: '子标题',
    },
    data: {
      type: ControlType.Json,
      title: '图表数据',
      defaultValue: [
        { stage: '简历筛选', number: 253 },
        { stage: '初试人数', number: 151 },
        { stage: '复试人数', number: 113 },
        { stage: '录取人数', number: 87 },
        { stage: '入职人数', number: 59 },
      ],
    },
    xField: {
      type: ControlType.Enum,
      title: 'x轴',
      autoComplete: true,
      options: (props.data?.length &&
        Object.keys(props.data[0]).map(key => ({
          label: key,
          value: key,
        }))) || ['x'],
    },
    yField: {
      type: ControlType.Enum,
      title: 'y轴',
      autoComplete: true,
      options: (props.data?.length &&
        Object.keys(props.data[0]).map(key => ({
          label: key,
          value: key,
        }))) || ['y'],
    },
    legend: {
      type: ControlType.Boolean,
      title: '图例显示',
    },
    width: {
      type: ControlType.Number,
      title: '宽度',
    },
    height: {
      type: ControlType.Number,
      title: '高度',
    },
  });
});
